package com.blitzagency.xray.logger
{
   import com.blitzagency.xray.logger.events.DebugDispatcher;
   import flash.events.StatusEvent;
   import flash.net.LocalConnection;
   import flash.utils.*;
   
   public class Debug
   {
      private static var xrayLC:LocalConnection;
      
      private static var connected:Boolean = false;
      
      private static var ed:DebugDispatcher = new DebugDispatcher();
      
      public function Debug()
      {
         super();
      }
      
      public static function traceObject(param1:Object, param2:Number = 254, param3:Number = 0, param4:String = "", param5:Number = 0) : void
      {
         var recurseDepth:Number = NaN;
         var indent:Number = NaN;
         var prop:String = null;
         var lead:String = null;
         var i:Number = NaN;
         var obj:String = null;
         var o:Object = param1;
         var pRecurseDepth:Number = param2;
         var pIndent:Number = param3;
         var pPackage:String = param4;
         var pLevel:Number = param5;
         try
         {
            recurseDepth = pRecurseDepth;
            indent = pIndent;
            for(prop in o)
            {
               lead = "";
               i = 0;
               while(i < indent)
               {
                  lead += "    ";
                  i++;
               }
               obj = o[prop].toString();
               if(o[prop] is Array)
               {
                  obj = "[Array]";
               }
               if(obj == "[object Object]")
               {
                  obj = "[Object]";
               }
               Debug.trace(lead + prop + ": " + obj,pPackage,pLevel);
               if(recurseDepth > 0)
               {
                  Debug.traceObject(o[prop],recurseDepth - 1,indent + 1,pPackage,pLevel);
               }
            }
         }
         catch(e:Error)
         {
         }
      }
      
      public static function trace(param1:Object, param2:String = "", param3:Number = 0) : void
      {
         var msg:String = null;
         var pMsg:Object = param1;
         var pPackage:String = param2;
         var pLevel:Number = param3;
         ed.sendEvent(DebugDispatcher.TRACE,{
            "message":pMsg,
            "classPackage":pPackage
         });
         if(!connected)
         {
            makeConnection();
         }
         if(connected)
         {
            try
            {
               msg = String(pMsg).length >= 39995 ? String(pMsg).substr(0,39995) + "..." : String(pMsg);
               xrayLC.send("_xray_view_conn","setTrace",msg,pLevel,pPackage);
            }
            catch(e:LogError)
            {
               LogError("No Xray Interface running");
            }
         }
      }
      
      private static function makeConnection() : void
      {
         var err:LogError = null;
         xrayLC = new LocalConnection();
         xrayLC.addEventListener("status",statusHandler);
         xrayLC.allowDomain("*");
         try
         {
            xrayLC.connect("_xray_standAlone_debug" + getTimer());
            connected = true;
         }
         catch(e:Error)
         {
            err = new LogError("log");
            setTimeout(makeConnection,1000);
         }
      }
      
      public static function addEventListener(param1:String, param2:Function) : void
      {
         ed.addEventListener(param1,param2);
      }
      
      private static function initialize() : Boolean
      {
         ed = new DebugDispatcher();
         return true;
      }
      
      private static function statusHandler(param1:StatusEvent) : void
      {
         if(param1.code == null && param1.level == "error" && connected)
         {
            connected = false;
         }
         else if(param1.level == "status" && param1.code == null)
         {
            connected = true;
         }
      }
   }
}

class LogError extends Error
{
   public function LogError(param1:String)
   {
      super(param1);
   }
}
