package com.blitzagency.xray.logger
{
   import com.blitzagency.xray.logger.util.ObjectTools;
   
   public class Log
   {
      private var level:Number;
      
      private var caller:String = "";
      
      private var classPackage:String;
      
      private var dump:Object;
      
      private var message:String;
      
      public function Log(param1:String, param2:Object, param3:Number, ... rest)
      {
         var err:LogError = null;
         var nullArray:Array = null;
         var str:String = null;
         var p_message:String = param1;
         var p_dump:Object = param2;
         var p_level:Number = param3;
         caller = "";
         super();
         try
         {
            nullArray.push("bogus");
         }
         catch(e:Error)
         {
            err = new LogError("log");
         }
         finally
         {
            if(err.hasOwnProperty("getStackTrace"))
            {
               str = err.getStackTrace();
               setCaller(resolveCaller(str));
            }
            else
            {
               setCaller("");
            }
            setMessage(p_message);
            setDump(p_dump);
            setLevel(p_level);
            setClassPackage(p_dump);
         }
      }
      
      public function setLevel(param1:Number) : void
      {
         level = param1;
      }
      
      public function getCaller() : String
      {
         return caller;
      }
      
      public function setMessage(param1:String) : void
      {
         message = param1;
      }
      
      public function getLevel() : Number
      {
         return level;
      }
      
      public function getDump() : Object
      {
         return dump;
      }
      
      public function setCaller(param1:String) : void
      {
         caller = param1;
      }
      
      public function setClassPackage(param1:Object) : void
      {
         classPackage = ObjectTools.getImmediateClassPath(param1);
      }
      
      public function getMessage() : String
      {
         return message;
      }
      
      public function getClassPackage() : String
      {
         return classPackage;
      }
      
      public function setDump(param1:Object) : void
      {
         dump = param1;
      }
      
      private function resolveCaller(param1:String) : String
      {
         var ary:Array = null;
         var str:String = param1;
         ary = [];
         try
         {
            str = str.split("\n").join("");
            ary = str.split("\tat ");
            str = ary[3];
         }
         catch(e:Error)
         {
         }
         finally
         {
            str = "";
         }
         return str;
      }
   }
}

class LogError extends Error
{
   public function LogError(param1:String)
   {
      super(param1);
   }
}
