package com.blitzagency.xray.logger
{
   import com.blitzagency.xray.logger.util.ObjectTools;
   import com.blitzagency.xray.logger.util.PropertyTools;
   import flash.events.EventDispatcher;
   import flash.utils.*;
   
   public class XrayLogger extends EventDispatcher implements Logger
   {
      public static var DEBUG:Number = 0;
      
      public static var INFO:Number = 1;
      
      public static var WARN:Number = 2;
      
      public static var ERROR:Number = 3;
      
      public static var FATAL:Number = 4;
      
      public static var NONE:Number = 5;
      
      private static var _instance:XrayLogger = null;
      
      private var displayObjectRecursionDepth:Number = 3;
      
      private var level:Number = 0;
      
      private var indentation:Number = 0;
      
      private var objectRecursionDepth:Number = 254;
      
      private var filters:Array;
      
      public function XrayLogger()
      {
         level = 0;
         displayObjectRecursionDepth = 3;
         objectRecursionDepth = 254;
         indentation = 0;
         filters = [];
         super();
      }
      
      public static function getInstance() : XrayLogger
      {
         if(_instance == null)
         {
            _instance = new XrayLogger();
         }
         return _instance;
      }
      
      public static function resolveLevelAsName(param1:Number) : String
      {
         switch(param1)
         {
            case 0:
               return "debug";
            case 1:
               return "info";
            case 2:
               return "warn";
            case 3:
               return "error";
            case 4:
               return "fatal";
            default:
               return "debug";
         }
      }
      
      public function checkFilters() : Boolean
      {
         var _loc1_:uint = 0;
         if(filters.length == 0)
         {
            return true;
         }
         _loc1_ = 0;
         while(_loc1_ < filters.length)
         {
            _loc1_++;
         }
         return true;
      }
      
      public function debug(param1:Log) : void
      {
         if(param1.getLevel() == level)
         {
            log(param1.getMessage(),param1.getCaller(),param1.getClassPackage(),0,param1.getDump());
         }
      }
      
      public function setIndentation(param1:Number = 0) : void
      {
         indentation = param1;
      }
      
      public function error(param1:Log) : void
      {
         if(param1.getLevel() >= level)
         {
            log(param1.getMessage(),param1.getCaller(),param1.getClassPackage(),3,param1.getDump());
         }
      }
      
      public function setLevel(param1:Number = 0) : void
      {
         level = param1;
      }
      
      public function fatal(param1:Log) : void
      {
         if(param1.getLevel() >= level)
         {
            log(param1.getMessage(),param1.getCaller(),param1.getClassPackage(),4,param1.getDump());
         }
      }
      
      public function warn(param1:Log) : void
      {
         if(param1.getLevel() >= level)
         {
            log(param1.getMessage(),param1.getCaller(),param1.getClassPackage(),2,param1.getDump());
         }
      }
      
      public function setObjectRecursionDepth(param1:Number) : void
      {
         objectRecursionDepth = param1;
      }
      
      public function setDisplayClipRecursionDepth(param1:Number) : void
      {
         displayObjectRecursionDepth = param1;
      }
      
      public function info(param1:Log) : void
      {
         if(param1.getLevel() >= level)
         {
            log(param1.getMessage(),param1.getCaller(),param1.getClassPackage(),1,param1.getDump());
         }
      }
      
      public function log(param1:String, param2:String, param3:String, param4:Number, param5:Object = null) : void
      {
         var _loc6_:* = null;
         var _loc7_:* = null;
         var _loc8_:String = null;
         var _loc9_:Object = null;
         _loc6_ = "(" + getTimer() + ") ";
         if(param3.length > 0)
         {
            _loc6_ += param2 + "\n";
         }
         _loc6_ += param1;
         if(param1.length > 0)
         {
            Debug.trace(_loc6_,param3,param4);
         }
         if(param5 == null)
         {
            return;
         }
         _loc7_ = typeof param5;
         if(_loc7_ == "string" || _loc7_ == "number" || _loc7_ == "boolean" || _loc7_ == "undefined" || _loc7_ == "null")
         {
            Debug.trace(param5,param3,param4);
         }
         else if(_loc7_ == "xml")
         {
            Debug.trace(param5.toString(),param3,param4);
         }
         else
         {
            _loc8_ = ObjectTools.getImmediateClassPath(param5);
            if(_loc8_ == "Object" || _loc8_ == "Object.Array")
            {
               Debug.traceObject(param5,objectRecursionDepth,indentation,param3,param4);
            }
            else
            {
               _loc9_ = PropertyTools.getProperties(param5);
               Debug.traceObject(_loc9_,displayObjectRecursionDepth,indentation,param3,param4);
            }
         }
      }
      
      public function setFilters(param1:Array) : void
      {
         filters = param1;
      }
   }
}

