package org.papervision3d.core.culling
{
   import org.papervision3d.core.geom.Face3DInstance;
   import org.papervision3d.core.geom.Vertex2D;
   import org.papervision3d.core.proto.MaterialObject3D;
   import org.papervision3d.objects.DisplayObject3D;
   
   public class DefaultTriangleCuller implements ITriangleCuller
   {
      private static var y2:Number;
      
      private static var y1:Number;
      
      private static var y0:Number;
      
      private static var x0:Number;
      
      private static var x1:Number;
      
      private static var x2:Number;
      
      public function DefaultTriangleCuller()
      {
         super();
      }
      
      public function testFace(param1:DisplayObject3D, param2:Face3DInstance, param3:Vertex2D, param4:Vertex2D, param5:Vertex2D) : Boolean
      {
         var _loc6_:MaterialObject3D = null;
         if(param3.visible && param4.visible && param5.visible)
         {
            _loc6_ = Boolean(param2.face.materialName) && Boolean(param1.materials) ? param1.materials.materialsByName[param2.face.materialName] : param1.material;
            if(_loc6_.invisible)
            {
               return false;
            }
            x0 = param3.x;
            y0 = param3.y;
            x1 = param4.x;
            y1 = param4.y;
            x2 = param5.x;
            y2 = param5.y;
            if(_loc6_.oneSide)
            {
               if(_loc6_.opposite)
               {
                  if((x2 - x0) * (y1 - y0) - (y2 - y0) * (x1 - x0) > 0)
                  {
                     return false;
                  }
               }
               else if((x2 - x0) * (y1 - y0) - (y2 - y0) * (x1 - x0) < 0)
               {
                  return false;
               }
            }
            return true;
         }
         return false;
      }
   }
}

