package org.papervision3d.core.geom
{
   import flash.display.Sprite;
   import org.papervision3d.core.Number3D;
   import org.papervision3d.core.proto.MaterialObject3D;
   import org.papervision3d.objects.DisplayObject3D;
   
   public class Face3D
   {
      private static var _totalFaces:Number = 0;
      
      public var face3DInstance:Face3DInstance;
      
      public var visible:Boolean;
      
      public var materialName:String;
      
      public var id:Number;
      
      public var uv:Array;
      
      public var faceNormal:Number3D;
      
      public var screenZ:Number;
      
      public var vertices:Array;
      
      public var v0:Vertex3D;
      
      public var v1:Vertex3D;
      
      public var v2:Vertex3D;
      
      public function Face3D(param1:Array, param2:String = null, param3:Array = null)
      {
         super();
         this.vertices = param1;
         v0 = param1[0];
         v1 = param1[1];
         v2 = param1[2];
         this.materialName = param2;
         this.uv = param3;
         this.id = _totalFaces++;
         face3DInstance = new Face3DInstance(this);
      }
      
      public function render(param1:DisplayObject3D, param2:Sprite) : Number
      {
         var _loc3_:MaterialObject3D = null;
         _loc3_ = Boolean(this.materialName) && Boolean(param1.materials) ? param1.materials.materialsByName[this.materialName] : param1.material;
         return _loc3_.drawFace3D(param1,this,param2.graphics,v0.vertex2DInstance,v1.vertex2DInstance,v2.vertex2DInstance);
      }
      
      protected function createNormal() : void
      {
         var _loc1_:Number3D = null;
         var _loc2_:Number3D = null;
         var _loc3_:Number3D = null;
         var _loc4_:Number3D = null;
         var _loc5_:Number3D = null;
         _loc1_ = v0.toNumber3D();
         _loc2_ = v1.toNumber3D();
         _loc3_ = v2.toNumber3D();
         _loc4_ = Number3D.sub(_loc2_,_loc1_);
         _loc5_ = Number3D.sub(_loc3_,_loc1_);
         faceNormal = Number3D.cross(_loc5_,_loc4_);
         faceNormal.normalize();
      }
   }
}

