package org.papervision3d.core.geom
{
   import org.papervision3d.core.*;
   import org.papervision3d.core.culling.ITriangleCuller;
   import org.papervision3d.core.proto.*;
   import org.papervision3d.objects.DisplayObject3D;
   
   public class Mesh3D extends Vertices3D
   {
      public function Mesh3D(param1:MaterialObject3D, param2:Array, param3:Array, param4:String = null, param5:Object = null)
      {
         super(param2,param4,param5);
         this.geometry.faces = param3 || new Array();
         this.material = param1 || MaterialObject3D.DEFAULT;
      }
      
      override public function project(param1:DisplayObject3D, param2:CameraObject3D, param3:Array = null) : Number
      {
         var _loc4_:Array = null;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:ITriangleCuller = null;
         var _loc8_:Vertex2D = null;
         var _loc9_:Vertex2D = null;
         var _loc10_:Vertex2D = null;
         var _loc11_:Face3DInstance = null;
         var _loc12_:Face3D = null;
         super.project(param1,param2,param3);
         if(!param3)
         {
            param3 = this._sorted;
         }
         _loc4_ = this.geometry.faces;
         _loc5_ = 0;
         _loc6_ = 0;
         _loc7_ = scene.triangleCuller;
         for each(_loc12_ in _loc4_)
         {
            _loc11_ = _loc12_.face3DInstance;
            _loc11_.instance = this;
            _loc8_ = _loc12_.v0.vertex2DInstance;
            _loc9_ = _loc12_.v1.vertex2DInstance;
            _loc10_ = _loc12_.v2.vertex2DInstance;
            if(_loc11_.visible = _loc7_.testFace(this,_loc11_,_loc8_,_loc9_,_loc10_))
            {
               if(Boolean(material) && material.needsFaceNormals)
               {
                  _loc12_.faceNormal.copyTo(_loc11_.faceNormal);
                  Matrix3D.multiplyVector3x3(this.view,_loc11_.faceNormal);
               }
               switch(meshSort)
               {
                  case DisplayObject3D.MESH_SORT_CENTER:
                     _loc5_ += _loc11_.screenZ = (_loc8_.z + _loc9_.z + _loc10_.z) * 0.333;
                     break;
                  case DisplayObject3D.MESH_SORT_FAR:
                     _loc5_ += _loc11_.screenZ = Math.max(_loc8_.z,_loc9_.z,_loc10_.z);
                     break;
                  case DisplayObject3D.MESH_SORT_CLOSE:
                     _loc5_ += _loc11_.screenZ = Math.min(_loc8_.z,_loc9_.z,_loc10_.z);
               }
               _loc6_++;
               param3.push(_loc11_);
            }
            else
            {
               ++scene.stats.culledTriangles;
            }
         }
         return this.screenZ = _loc5_ / _loc6_;
      }
      
      public function projectTexture(param1:String = "x", param2:String = "y") : void
      {
         var _loc3_:Array = null;
         var _loc4_:Object = null;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         var _loc9_:MaterialObject3D = null;
         var _loc10_:String = null;
         var _loc11_:Face3D = null;
         var _loc12_:Array = null;
         var _loc13_:Vertex3D = null;
         var _loc14_:Vertex3D = null;
         var _loc15_:Vertex3D = null;
         var _loc16_:NumberUV = null;
         var _loc17_:NumberUV = null;
         var _loc18_:NumberUV = null;
         _loc3_ = this.geometry.faces;
         _loc4_ = this.boundingBox();
         _loc5_ = Number(_loc4_.min[param1]);
         _loc6_ = Number(_loc4_.size[param1]);
         _loc7_ = Number(_loc4_.min[param2]);
         _loc8_ = Number(_loc4_.size[param2]);
         _loc9_ = this.material;
         for(_loc10_ in _loc3_)
         {
            _loc11_ = _loc3_[Number(_loc10_)];
            _loc12_ = _loc11_.vertices;
            _loc13_ = _loc12_[0];
            _loc14_ = _loc12_[1];
            _loc15_ = _loc12_[2];
            _loc16_ = new NumberUV((_loc13_[param1] - _loc5_) / _loc6_,(_loc13_[param2] - _loc7_) / _loc8_);
            _loc17_ = new NumberUV((_loc14_[param1] - _loc5_) / _loc6_,(_loc14_[param2] - _loc7_) / _loc8_);
            _loc18_ = new NumberUV((_loc15_[param1] - _loc5_) / _loc6_,(_loc15_[param2] - _loc7_) / _loc8_);
            _loc11_.uv = [_loc16_,_loc17_,_loc18_];
         }
      }
   }
}

