package org.papervision3d.core.proto
{
   import org.papervision3d.core.Matrix3D;
   import org.papervision3d.core.Number3D;
   import org.papervision3d.objects.DisplayObject3D;
   
   public class CameraObject3D extends DisplayObject3D
   {
      public static var DEFAULT_POS:Number3D = new Number3D(0,0,-1000);
      
      private static var _flipY:Matrix3D = Matrix3D.scaleMatrix(1,-1,1);
      
      public var sort:Boolean;
      
      public var zoom:Number;
      
      public var focus:Number;
      
      public function CameraObject3D(param1:Number = 3, param2:Number = 500, param3:Object = null)
      {
         super();
         this.x = !!param3 ? Number(param3.x) || DEFAULT_POS.x : DEFAULT_POS.x;
         this.y = !!param3 ? Number(param3.y) || DEFAULT_POS.y : DEFAULT_POS.y;
         this.z = !!param3 ? Number(param3.z) || DEFAULT_POS.z : DEFAULT_POS.z;
         this.zoom = param1;
         this.focus = param2;
         this.sort = !!param3 ? param3.sort != false : true;
      }
      
      public function transformView(param1:Matrix3D = null) : void
      {
         this.view = Matrix3D.inverse(Matrix3D.multiply(param1 || this.transform,_flipY));
      }
      
      public function pan(param1:Number) : void
      {
         super.yaw(param1);
      }
      
      public function tilt(param1:Number) : void
      {
         super.pitch(param1);
      }
   }
}

