package org.papervision3d.core.proto
{
   import flash.events.EventDispatcher;
   import flash.utils.Dictionary;
   import org.papervision3d.Papervision3D;
   import org.papervision3d.materials.MaterialsList;
   import org.papervision3d.objects.DisplayObject3D;
   
   public class DisplayObjectContainer3D extends EventDispatcher
   {
      protected var _children:Dictionary;
      
      public var root:DisplayObjectContainer3D;
      
      private var _childrenTotal:int;
      
      protected var _childrenByName:Object;
      
      public function DisplayObjectContainer3D()
      {
         super();
         this._children = new Dictionary(false);
         this._childrenByName = new Dictionary(true);
         this._childrenTotal = 0;
      }
      
      public function getChildByName(param1:String) : DisplayObject3D
      {
         return this._childrenByName[param1];
      }
      
      public function addCollada(param1:String, param2:MaterialsList = null, param3:Number = 1) : void
      {
         Papervision3D.log("The addCollada() method has been deprecated. Use addChildren( new Collada( filename ) )");
      }
      
      public function removeChildByName(param1:String) : DisplayObject3D
      {
         return removeChild(getChildByName(param1));
      }
      
      public function get numChildren() : int
      {
         return this._childrenTotal;
      }
      
      override public function toString() : String
      {
         return childrenList();
      }
      
      public function addChildren(param1:DisplayObject3D) : DisplayObjectContainer3D
      {
         var _loc2_:DisplayObject3D = null;
         for each(_loc2_ in param1.children)
         {
            param1.removeChild(_loc2_);
            this.addChild(_loc2_);
         }
         return this;
      }
      
      public function removeChild(param1:DisplayObject3D) : DisplayObject3D
      {
         delete this._childrenByName[this._children[param1]];
         delete this._children[param1];
         param1.parent = null;
         param1.root = null;
         return param1;
      }
      
      public function addChild(param1:DisplayObject3D, param2:String = null) : DisplayObject3D
      {
         param2 = param2 || param1.name || String(param1.id);
         this._children[param1] = param2;
         this._childrenByName[param2] = param1;
         ++this._childrenTotal;
         param1.parent = this;
         param1.root = this.root;
         return param1;
      }
      
      public function childrenList() : String
      {
         var _loc1_:String = null;
         var _loc2_:String = null;
         _loc1_ = "";
         for(_loc2_ in this._children)
         {
            _loc1_ += _loc2_ + "\n";
         }
         return _loc1_;
      }
      
      public function get children() : Object
      {
         return this._childrenByName;
      }
   }
}

