package org.papervision3d.core.proto
{
   import flash.events.EventDispatcher;
   import org.papervision3d.core.*;
   import org.papervision3d.core.geom.*;
   import org.papervision3d.materials.*;
   import org.papervision3d.scenes.*;
   
   public class GeometryObject3D extends EventDispatcher
   {
      protected var _boundingSphere2:Number;
      
      protected var _boundingSphereDirty:Boolean = true;
      
      public var ready:Boolean = false;
      
      protected var _material:MaterialObject3D;
      
      public var faces:Array;
      
      public var vertices:Array;
      
      public function GeometryObject3D(param1:Object = null)
      {
         ready = false;
         _boundingSphereDirty = true;
         super();
      }
      
      public function transformVertices(param1:Matrix3D) : void
      {
      }
      
      public function get boundingSphere2() : Number
      {
         if(_boundingSphereDirty)
         {
            return getBoundingSphere2();
         }
         return _boundingSphere2;
      }
      
      public function getBoundingSphere2() : Number
      {
         var _loc1_:Number = NaN;
         var _loc2_:Number = NaN;
         var _loc3_:Vertex3D = null;
         _loc1_ = 0;
         for each(_loc3_ in this.vertices)
         {
            _loc2_ = _loc3_.x * _loc3_.x + _loc3_.y * _loc3_.y + _loc3_.z * _loc3_.z;
            _loc1_ = _loc2_ > _loc1_ ? _loc2_ : _loc1_;
         }
         this._boundingSphereDirty = false;
         return _boundingSphere2 = _loc1_;
      }
      
      public function transformUV(param1:MaterialObject3D) : void
      {
         var _loc2_:String = null;
         if(param1.bitmap)
         {
            for(_loc2_ in this.faces)
            {
               faces[_loc2_].transformUV(param1);
            }
         }
      }
   }
}

