package org.papervision3d.core.proto
{
   import flash.display.BitmapData;
   import flash.display.Graphics;
   import flash.events.EventDispatcher;
   import org.papervision3d.core.draw.IFaceDrawer;
   import org.papervision3d.core.geom.Face3D;
   import org.papervision3d.core.geom.Vertex2D;
   import org.papervision3d.objects.DisplayObject3D;
   
   public class MaterialObject3D extends EventDispatcher implements IFaceDrawer
   {
      public static var DEFAULT_COLOR:int = 0;
      
      public static var DEBUG_COLOR:int = 16711935;
      
      private static var _totalMaterialObjects:Number = 0;
      
      public var maxV:Number;
      
      public var name:String;
      
      public var scene:SceneObject3D;
      
      public var fillAlpha:Number;
      
      public var needsFaceNormals:Boolean = false;
      
      public var fillColor:Number;
      
      public var id:Number;
      
      public var invisible:Boolean;
      
      public var smooth:Boolean;
      
      public var bitmap:BitmapData;
      
      public var lineColor:Number;
      
      public var lineAlpha:Number;
      
      public var oneSide:Boolean;
      
      public var lineThickness:Number = 1;
      
      public var opposite:Boolean;
      
      public var maxU:Number;
      
      public function MaterialObject3D(param1:Object = null)
      {
         lineThickness = 1;
         needsFaceNormals = false;
         super();
         if(Boolean(param1) && Boolean(param1.bitmap))
         {
            this.bitmap = param1.bitmap;
         }
         this.lineColor = !!param1 ? Number(param1.lineColor) || DEFAULT_COLOR : DEFAULT_COLOR;
         this.lineAlpha = !!param1 ? Number(param1.lineAlpha) || 0 : 0;
         this.fillColor = !!param1 ? Number(param1.fillColor) || DEFAULT_COLOR : DEFAULT_COLOR;
         this.fillAlpha = !!param1 ? Number(param1.fillAlpha) || 0 : 0;
         this.invisible = !!param1 ? Boolean(param1.invisible) : false;
         this.smooth = !!param1 ? Boolean(param1.smooth) : false;
         this.doubleSided = !!param1 ? Boolean(param1.doubleSided) : false;
         this.opposite = !!param1 ? Boolean(param1.opposite) : false;
         this.id = _totalMaterialObjects++;
      }
      
      public static function get DEFAULT() : MaterialObject3D
      {
         var _loc1_:MaterialObject3D = null;
         _loc1_ = new MaterialObject3D();
         _loc1_.lineColor = 16777215 * Math.random();
         _loc1_.lineAlpha = 1;
         _loc1_.fillColor = DEFAULT_COLOR;
         _loc1_.fillAlpha = 1;
         _loc1_.doubleSided = false;
         return _loc1_;
      }
      
      public static function get DEBUG() : MaterialObject3D
      {
         var _loc1_:MaterialObject3D = null;
         _loc1_ = new MaterialObject3D();
         _loc1_.lineColor = 16777215 * Math.random();
         _loc1_.lineAlpha = 1;
         _loc1_.fillColor = DEBUG_COLOR;
         _loc1_.fillAlpha = 0.37;
         _loc1_.doubleSided = true;
         return _loc1_;
      }
      
      public function get doubleSided() : Boolean
      {
         return !this.oneSide;
      }
      
      public function set doubleSided(param1:Boolean) : void
      {
         this.oneSide = !param1;
      }
      
      public function updateBitmap() : void
      {
      }
      
      override public function toString() : String
      {
         return "[MaterialObject3D] bitmap:" + this.bitmap + " lineColor:" + this.lineColor + " fillColor:" + fillColor;
      }
      
      public function copy(param1:MaterialObject3D) : void
      {
         this.bitmap = param1.bitmap;
         this.smooth = param1.smooth;
         this.lineColor = param1.lineColor;
         this.lineAlpha = param1.lineAlpha;
         this.fillColor = param1.fillColor;
         this.fillAlpha = param1.fillAlpha;
         this.oneSide = param1.oneSide;
         this.opposite = param1.opposite;
         this.invisible = param1.invisible;
         this.scene = param1.scene;
         this.name = param1.name;
      }
      
      public function drawFace3D(param1:DisplayObject3D, param2:Face3D, param3:Graphics, param4:Vertex2D, param5:Vertex2D, param6:Vertex2D) : int
      {
         return 0;
      }
      
      public function clone() : MaterialObject3D
      {
         var _loc1_:MaterialObject3D = null;
         _loc1_ = new MaterialObject3D();
         _loc1_.copy(this);
         return _loc1_;
      }
   }
}

