package org.papervision3d.core.proto
{
   import flash.display.Sprite;
   import flash.utils.Dictionary;
   import flash.utils.getTimer;
   import org.papervision3d.Papervision3D;
   import org.papervision3d.core.culling.DefaultTriangleCuller;
   import org.papervision3d.core.culling.ITriangleCuller;
   import org.papervision3d.core.stat.RenderStatistics;
   import org.papervision3d.materials.MaterialsList;
   import org.papervision3d.materials.MovieMaterial;
   import org.papervision3d.objects.DisplayObject3D;
   
   public class SceneObject3D extends DisplayObjectContainer3D
   {
      public var container:Sprite;
      
      public var triangleCuller:ITriangleCuller;
      
      private var geometries:Dictionary;
      
      public var objects:Array;
      
      public var stats:RenderStatistics;
      
      public var materials:MaterialsList;
      
      public function SceneObject3D(param1:Sprite)
      {
         triangleCuller = new DefaultTriangleCuller();
         super();
         if(param1)
         {
            this.container = param1;
         }
         else
         {
            Papervision3D.log("Scene3D: container argument required.");
         }
         this.objects = new Array();
         this.materials = new MaterialsList();
         Papervision3D.log(Papervision3D.NAME + " " + Papervision3D.VERSION + " (" + Papervision3D.DATE + ")\n");
         this.stats = new RenderStatistics();
         this.stats.points = 0;
         this.stats.polys = 0;
         this.stats.triangles = 0;
         this.stats.performance = 0;
         this.stats.rendered = 0;
         this.root = this;
      }
      
      override public function addChild(param1:DisplayObject3D, param2:String = null) : DisplayObject3D
      {
         var _loc3_:DisplayObject3D = null;
         _loc3_ = super.addChild(param1,param2);
         param1.scene = this;
         this.objects.push(_loc3_);
         return _loc3_;
      }
      
      public function renderCamera(param1:CameraObject3D) : void
      {
         var _loc2_:Array = null;
         var _loc3_:DisplayObject3D = null;
         var _loc4_:Number = NaN;
         stats.clear();
         stats.performance = getTimer();
         MovieMaterial.updateAnimatedBitmaps();
         if(param1)
         {
            param1.transformView();
            _loc2_ = this.objects;
            _loc4_ = _loc2_.length;
            while(true)
            {
               _loc3_ = _loc2_[--_loc4_];
               if(!_loc3_)
               {
                  break;
               }
               if(_loc3_.visible)
               {
                  _loc3_.project(param1,param1);
               }
            }
         }
         if(param1.sort)
         {
            this.objects.sortOn("screenZ",Array.NUMERIC);
         }
         renderObjects(param1.sort);
      }
      
      protected function renderObjects(param1:Boolean) : void
      {
      }
      
      override public function removeChild(param1:DisplayObject3D) : DisplayObject3D
      {
         var _loc2_:int = 0;
         super.removeChild(param1);
         _loc2_ = 0;
         while(_loc2_ < this.objects.length)
         {
            if(this.objects[_loc2_] === param1)
            {
               this.objects.splice(_loc2_,1);
               return param1;
            }
            _loc2_++;
         }
         return param1;
      }
   }
}

