package org.papervision3d.materials
{
   import flash.display.Bitmap;
   import flash.display.BitmapData;
   import flash.display.Graphics;
   import flash.display.Loader;
   import flash.events.*;
   import flash.net.URLRequest;
   import flash.utils.Dictionary;
   import org.papervision3d.Papervision3D;
   import org.papervision3d.core.geom.Face3D;
   import org.papervision3d.core.geom.Vertex2D;
   import org.papervision3d.core.proto.MaterialObject3D;
   import org.papervision3d.events.FileLoadEvent;
   import org.papervision3d.objects.DisplayObject3D;
   
   public class BitmapFileMaterial extends BitmapMaterial
   {
      public static var callback:Function;
      
      public static var LOADING_COLOR:int = MaterialObject3D.DEFAULT_COLOR;
      
      private static var _waitingBitmaps:Array = new Array();
      
      private static var _loaderUrls:Dictionary = new Dictionary();
      
      private static var _loadedBitmaps:Object = new Object();
      
      private static var _subscribedMaterials:Object = new Object();
      
      private static var _loadingIdle:Boolean = true;
      
      public var loaded:Boolean;
      
      public var url:String = "";
      
      public function BitmapFileMaterial(param1:String, param2:Object = null)
      {
         url = "";
         super(param1,param2);
         this.url = param1;
         this.loaded = false;
         this.fillAlpha = 1;
         this.fillColor = LOADING_COLOR;
      }
      
      private function loadNextBitmap() : void
      {
         var file:String = null;
         var request:URLRequest = null;
         var bitmapLoader:Loader = null;
         file = _waitingBitmaps[0];
         request = new URLRequest(file);
         bitmapLoader = new Loader();
         bitmapLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,loadBitmapProgressHandler);
         bitmapLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,loadBitmapCompleteHandler);
         try
         {
            bitmapLoader.load(request);
            _loaderUrls[bitmapLoader] = file;
            _loadingIdle = false;
            Papervision3D.log("BitmapFileMaterial: Loading bitmap from " + file);
         }
         catch(error:Error)
         {
            _waitingBitmaps.shift();
            _loadingIdle = true;
            Papervision3D.log("[ERROR] BitmapFileMaterial: Unable to load file " + error.message);
         }
      }
      
      private function loadBitmapCompleteHandler(param1:Event) : void
      {
         var _loc2_:Loader = null;
         var _loc3_:Bitmap = null;
         var _loc4_:String = null;
         var _loc5_:BitmapData = null;
         var _loc6_:BitmapFileMaterial = null;
         _loc2_ = Loader(param1.target.loader);
         _loc3_ = Bitmap(_loc2_.content);
         _loc4_ = _loaderUrls[_loc2_];
         _loc5_ = correctBitmap(_loc3_.bitmapData,true);
         for each(_loc6_ in _subscribedMaterials[_loc4_])
         {
            _loc6_.bitmap = _loc5_;
            _loc6_.maxU = this.maxU;
            _loc6_.maxV = this.maxV;
            _loc6_.loadComplete();
         }
         _loadedBitmaps[_loc4_] = _loc5_;
         _waitingBitmaps.shift();
         if(_waitingBitmaps.length > 0)
         {
            loadNextBitmap();
         }
         else
         {
            _loadingIdle = true;
            if(Boolean(callback))
            {
               callback();
            }
         }
      }
      
      override public function drawFace3D(param1:DisplayObject3D, param2:Face3D, param3:Graphics, param4:Vertex2D, param5:Vertex2D, param6:Vertex2D) : int
      {
         var _loc7_:int = 0;
         if(bitmap == null)
         {
            return 1;
         }
         bitmap.lock();
         _loc7_ = super.drawFace3D(param1,param2,param3,param4,param5,param6);
         bitmap.unlock();
         return _loc7_;
      }
      
      private function queueBitmap(param1:String) : void
      {
         if(!_subscribedMaterials[param1])
         {
            _waitingBitmaps.push(param1);
            _subscribedMaterials[param1] = new Array();
         }
         _subscribedMaterials[param1].push(this);
         if(_loadingIdle)
         {
            loadNextBitmap();
         }
      }
      
      private function loadComplete() : void
      {
         var _loc1_:FileLoadEvent = null;
         this.fillAlpha = 0;
         this.fillColor = 0;
         this.loaded = true;
         _loc1_ = new FileLoadEvent(FileLoadEvent.LOAD_COMPLETE,this.url);
         this.dispatchEvent(_loc1_);
      }
      
      override protected function createBitmap(param1:*) : BitmapData
      {
         var _loc2_:BitmapData = null;
         if(param1 == "")
         {
            return null;
         }
         if(_loadedBitmaps[param1])
         {
            _loc2_ = _loadedBitmaps[param1];
            this.loadComplete();
            return _loc2_;
         }
         queueBitmap(param1);
         return null;
      }
      
      private function loadBitmapProgressHandler(param1:ProgressEvent) : void
      {
         var _loc2_:FileLoadEvent = null;
         _loc2_ = new FileLoadEvent(FileLoadEvent.LOAD_PROGRESS,url,param1.bytesLoaded,param1.bytesTotal);
         dispatchEvent(_loc2_);
      }
   }
}

