package org.papervision3d.materials
{
   import flash.display.BitmapData;
   import flash.display.MovieClip;
   import flash.geom.Matrix;
   import flash.utils.Dictionary;
   
   public class MovieMaterial extends BitmapMaterial
   {
      private static var animatedMaterials:Dictionary = new Dictionary(false);
      
      public var movieTransparent:Boolean;
      
      public var movie:MovieClip;
      
      public function MovieMaterial(param1:*, param2:Boolean = false, param3:Object = null)
      {
         super(initBitmap(param1,param2),param3);
         animatedMaterials[this] = false;
      }
      
      public static function updateAnimatedBitmaps() : void
      {
         var _loc1_:Object = null;
         for(_loc1_ in animatedMaterials)
         {
            if(animatedMaterials[_loc1_])
            {
               _loc1_.updateBitmap();
            }
         }
      }
      
      public function get animated() : Boolean
      {
         return animatedMaterials[this];
      }
      
      public function set animated(param1:Boolean) : void
      {
         animatedMaterials[this] = param1;
      }
      
      override protected function createBitmap(param1:*) : BitmapData
      {
         if(this.bitmap)
         {
            this.bitmap.dispose();
         }
         this.bitmap = correctBitmap(new BitmapData(param1.width,param1.height,this.movieTransparent),true);
         this.movie = param1;
         updateBitmap();
         return this.bitmap;
      }
      
      override public function updateBitmap() : void
      {
         var _loc1_:BitmapData = null;
         var _loc2_:MovieClip = null;
         var _loc3_:Matrix = null;
         _loc1_ = this.bitmap;
         _loc2_ = this.movie;
         _loc1_.fillRect(_loc1_.rect,this.fillColor);
         _loc3_ = new Matrix();
         _loc3_.scale(_loc2_.scaleX,_loc2_.scaleY);
         _loc1_.draw(_loc2_,_loc3_,_loc2_.transform.colorTransform);
         extendBitmapEdges(_loc1_,_loc2_.width,_loc2_.height);
      }
      
      private function initBitmap(param1:*, param2:Boolean) : *
      {
         this.movieTransparent = param2;
         return param1;
      }
   }
}

